%define anolis_release 2

Summary:	Tool to translate x86-64 CPU Machine Check Exception data
Name:		mcelog
Version:	202
Release:	%{anolis_release}%{?dist}
Epoch:		3
License:	GPLv2
URL:		https://github.com/andikleen/mcelog
Source0:	%{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	mcelog.conf
ExclusiveArch:	x86_64 loongarch64 riscv64
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: gcc make systemd-rpm-macros

%description
mcelog is the user space backend for logging machine check errors
reported by the hardware to the kernel. 
The kernel does the immediate actions (like killing processes etc.)
and mcelog decodes the errors and manages various other advanced
error responses like offlining memory, CPUs or triggering events.
In addition mcelog also handles corrected errors, by logging and accounting them.
It primarily handles machine checks and thermal events,
which are reported for errors detected by the CPU.

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup

%build
%make_build CFLAGS="$RPM_OPT_FLAGS -fpie -pie"

%install
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man{5,8}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/triggers
mkdir -p $RPM_BUILD_ROOT/%{_unitdir}
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
install -p -m755 mcelog $RPM_BUILD_ROOT/%{_sbindir}/mcelog
install -p -m644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/mcelog.conf
install -p -m755 triggers/cache-error-trigger $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/triggers/cache-error-trigger
install -p -m755 triggers/dimm-error-trigger $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/triggers/dimm-error-trigger
install -p -m755 triggers/page-error-trigger $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/triggers/page-error-trigger
install -p -m755 triggers/socket-memory-error-trigger $RPM_BUILD_ROOT/%{_sysconfdir}/mcelog/triggers/socket-memory-error-trigger
install -p -m644 mcelog.service $RPM_BUILD_ROOT%{_unitdir}/mcelog.service
install -p -m644 mcelog*.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
install -p -m644 mcelog*.5 $RPM_BUILD_ROOT/%{_mandir}/man5/
%generate_compatibility_deps

%post
%systemd_post mcelog.service

%preun
%systemd_preun mcelog.service

%postun
%systemd_postun_with_restart mcelog.service

%files
%license LICENSE
%{_sbindir}/mcelog
%dir %{_sysconfdir}/mcelog
%{_sysconfdir}/mcelog/triggers
%config(noreplace) %{_sysconfdir}/mcelog/mcelog.conf
%{_unitdir}/mcelog.service
%{_mandir}/*/*
%dir %{abidir}
%{abidir}/mcelog-option.list

%files doc
%doc README.md CHANGES

%changelog
* Thu May 08 2025 Shangtong Guo <guo.shangtong@zte.com.cn> - 3:202-2
- add support for riscv64

* Tue Mar 18 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 3:202-1
- Update to 202 from 194

* Mon Sep 25 2023 Wenlong Zhang <zhangwenlong@loongson.cn> - 3:194-2
- Add loongarch64 support

* Fri Apr 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3:194-1
- init from upstream
